| threaddb 2.0 A file mapped memory container extension

Classes | Typedefs | Functions
tdb Namespace Reference

## Classes
struct | array_deleter
class | Box
| Box basic class definition. More...
struct | Cells
| Definition of a ode of the rgrid. More...
class | database
| C++ wrapper class of the threadDB file mapped memory container extension. More...
class | fromstream
| Converter of byte stream into fixed data item representation. More...
class | fromstream< std::string >
| Converter of byte stream into variable length data item representation. More...
struct | Functor
| Functor class receiving the queried elements. More...
class | istream
| Input stream implementation. More...
class | istreambuf
| Input stream buffer implementation. More...
class | ItemInfo
| C++ wrapper class to the threadDB_ItemInfo control structure. More...
class | key
| Wrapper class for storing key data items. More...
struct | Link
| Link helper class to the next node level. More...
class | LinkInfo
| C++ wrapper class to the threadDB_LinkInfo control structure. More...
class | ostream
| Output stream implementation. More...
class | ostreambuf
| Output stream buffer implementation. More...
struct | Point
| Point basic class definition. More...
class | pool
| Pool datastructure for keeping track and recycling open ItemHandles. More...
class | RandomGenerator
class | ReadInfo
| C++ wrapper class to the threadDB_ReadInfo control structure. More...
class | rgrid
| External representation of the rgrid structure. More...
class | rgrid_
| Internal representation of the rgrid structure. More...
class | ritem
| Wrapper class for storing data items in a random fashion. More...
class | sitem
| Wrapper class for storing data items in a sequential fashion. More...
struct | size_
| Trait class for size of fixed length data items. More...
struct | size_< std::string >
| Trait class for size of variable length data items (std::string). More...
struct | TaskInfo
| Query task information. More...
class | tostream
| Converter of fixed size data elements into a byte stream representation. More...
class | tostream< std::string >
| Converter of variable length data items into byte stream representation. More...

## Typedefs
typedef std::pair< ItemInfo, std::atomic< uint8_t > > | ItemHandle

## Functions
template<typename C , size_t D>
bool | intersects (const Box< C, D > &rLhs_p, const Box< C, D > &rRhs_p)
| Check intersection of two Boxes. More...
template<typename C , size_t D>
std::pair< Box< C, D >, int32_t > | index_ (const Box< C, D > &lhs_p, const Box< C, D > &rhs_p)
| Range index calculation specialization for n dimensional scenarios. More...
template<typename C >
std::pair< tdb::Box< C, 1 >, int32_t > | index_ (const tdb::Box< C, 1 > &lhs_p, const tdb::Box< C, 1 > &rhs_p)
| Range index calculation specialization for 1 dimensional scenarios. More...
template<typename C >
std::pair< tdb::Box< C, 2 >, int32_t > | index_ (const tdb::Box< C, 2 > &lhs_p, const tdb::Box< C, 2 > &rhs_p)
| Range index calculation specialization for 2 dimensional scenarios. More...
template<typename C >
std::pair< tdb::Box< C, 3 >, int32_t > | index_ (const tdb::Box< C, 3 > &lhs_p, const tdb::Box< C, 3 > &rhs_p)
| Range index calculation specialization for 3 dimensional scenarios. More...
void | threadStore (size_t idx_p, tdb::database *pthreaddb_p, const std::vector< uint64_t > *pPackageId_p)
void | threadRecover (size_t idx_p, tdb::database *pthreaddb_p, const std::vector< uint64_t > *pPackageId_p, const char *pStringValue_p, size_t CheckLen_p)

## Typedef Documentation

## ◆ ItemHandle

typedef std::pair<ItemInfo, std::atomic<uint8_t> > tdb::ItemHandle

## Function Documentation

## ◆ index_() [1/4]

template<typename C , size_t D>

std::pair<Box<C, D>, int32_t> tdb::index_ | ( | const Box< C, D > & | lhs_p,
|  | const Box< C, D > & | rhs_p
| ) |  |

Range index calculation specialization for n dimensional scenarios.

## ◆ index_() [2/4]

template<typename C >

std::pair<tdb::Box<C, 1>, int32_t> tdb::index_ | ( | const tdb::Box< C, 1 > & | lhs_p,
|  | const tdb::Box< C, 1 > & | rhs_p
| ) |  |

Range index calculation specialization for 1 dimensional scenarios.

## ◆ index_() [3/4]

template<typename C >

std::pair<tdb::Box<C, 2>, int32_t> tdb::index_ | ( | const tdb::Box< C, 2 > & | lhs_p,
|  | const tdb::Box< C, 2 > & | rhs_p
| ) |  |

Range index calculation specialization for 2 dimensional scenarios.

## ◆ index_() [4/4]

template<typename C >

std::pair<tdb::Box<C, 3>, int32_t> tdb::index_ | ( | const tdb::Box< C, 3 > & | lhs_p,
|  | const tdb::Box< C, 3 > & | rhs_p
| ) |  |

Range index calculation specialization for 3 dimensional scenarios.

## ◆ intersects()

template<typename C , size_t D>

bool tdb::intersects | ( | const Box< C, D > & | rLhs_p,
|  | const Box< C, D > & | rRhs_p
| ) |  |

Check intersection of two Boxes.

## ◆ threadRecover()

void tdb::threadRecover | ( | size_t | idx_p,
|  | tdb::database * | pthreaddb_p,
|  | const std::vector< uint64_t > * | pPackageId_p,
|  | const char * | pStringValue_p,
|  | size_t | CheckLen_p
| ) |  |

## ◆ threadStore()

void tdb::threadStore | ( | size_t | idx_p,
|  | tdb::database * | pthreaddb_p,
|  | const std::vector< uint64_t > * | pPackageId_p
| ) |  |